<template>
  <div class="page-root">
    <v-list two-line v-if="!!group">
      <product-list-item v-for="product in group.products" :key="product.id" :id="product.id">
        <template slot="actions">
          <v-btn
            icon
            title="Remove Item"
            @click="removeItem(product.id)"
            :disabled="!amounts[product.id]"
          >
            <v-icon>mdi-minus</v-icon>
          </v-btn>
          <span class="subheading">{{ amounts[product.id] || 0}}</span>
          <v-btn icon title="Add Item" @click="addItem(product.id)">
            <v-icon>mdi-plus</v-icon>
          </v-btn>
        </template>
      </product-list-item>
    </v-list>

    <!-- Speed Dial -->
    <v-speed-dial fixed bottom right v-model="speedDial">
      <v-btn dark fab title="Actions" slot="activator" v-model="speedDial" color="blue">
        <v-icon>mdi-dots-horizontal</v-icon>
        <v-icon>mdi-close</v-icon>
      </v-btn>

      <!-- Add credits button -->
      <v-btn fab dark small color="green" title="Buy Items" @click="$refs.buyProductsDialog.open()">
        <v-icon>mdi-card-text</v-icon>
      </v-btn>

      <!-- Clear button -->
      <v-btn fab dark small color="red" title="Clear Selections" @click="amounts = {}">
        <v-icon>mdi-close</v-icon>
      </v-btn>
    </v-speed-dial>

    <buy-products-dialog :amounts="amounts" ref="buyProductsDialog" @success="amounts= {}"/>
  </div>
</template>

<script>
import gql from "graphql-tag";
import ProductListItem from "@/components/list-items/ProductListItem";
import BuyProductsDialog from "@/components/dialogs/BuyProductsDialog";

export default {
  name: "store-page",
  components: { ProductListItem, BuyProductsDialog },
  data() {
    return {
      speedDial: false,
      group: null,
      amounts: {}
    };
  },
  apollo: {
    group: {
      query: gql`
        query($id: ID!) {
          group: productGroup(id: $id) {
            id
            name
            products {
              id
            }
          }
        }
      `,
      subscribeToMore: {
        document: gql`
          subscription($id: ID!) {
            productGroup(id: $id) {
              id
              name
              products {
                id
              }
            }
          }
        `,
        skip() {
          return !this.$route.params.group_id;
        },
        variables() {
          return {
            id: this.$route.params.group_id
          };
        }
      },
      skip() {
        return !this.$route.params.group_id;
      },
      variables() {
        return {
          id: this.$route.params.group_id
        };
      }
    }
  },
  methods: {
    addItem(product) {
      if (!this.amounts[product]) this.amounts[product] = 1;
      else this.amounts[product] += 1;
      this.amounts = { ...this.amounts };
    },
    removeItem(product) {
      if (!this.amounts[product]) return;
      if (this.amounts[product] === 1) delete this.amounts[product];
      else this.amounts[product] -= 1;
      this.amounts = { ...this.amounts };
    }
  }
};
</script>

<style lang="scss">
</style>

